<?php

class img_resize {
 
 
 var $force_identify = false;

 
 var $imgwidth = 0;
 var $imgheight = 0;
 var $imgdpix = 0;
 var $imgdpiy = 0;

 
 var $warn_on_error = false;

 
 var $errno = 0;

 
 var $file = "";
 var $cachedir = "";
 var $cachekey = "";
 var $imgtype = "";
 var $imgprops = array();
 var $normprops = array();
 var $normcachekey = "null";
 var $outfile = "";
 var $rendered = false;
 var $isDB = false;
 var $imgData = 0;
 var $id = 0;

 

 
 function img_resize($filename="", $id=0) {
 global $FILEPATH;
 $this->cachedir = "$FILEPATH/system/imgresize";
 if ($filename!="") $this->load_file($filename);
 if ($id>0) {
 
 
 $this->load_dbdata($id);
 }
 $this->getCacheKey();
 }

 
 function setCacheDir($directory) {
 if (is_dir($directory)) {
 $this->cachedir = $directory;
 $this->errno = 0;
 } else {
 $this->error("Der Cache-Pfad ist kein Verzeichnis oder existiert nicht.");
 $this->errno = 2;
 }
 return $this->errno;
 }

 function getCacheDir($directory) {
 return $this->cachedir;
 }

 
 function clearCache() {
 if($this->isDB) {
 $sql = "SELECT id,cachefile FROM imgresizecache WHERE filename = \"".sqlf_escaped("dbfile_".sqlslashes($this->id))."\"";
 } else {
 $sql = "SELECT id,cachefile FROM imgresizecache WHERE filename = \"".sqlslashes($this->file)."\"";
 }

 $rs = query($sql);

 while (list($key,$val) = each($rs["arr"])) {
 @unlink($this->cachedir."/".$val["cachefile"]);
 }
 if($this->isDB) {
 $sql = "DELETE FROM imgresizecache WHERE filename = \"".sqlf_escaped("dbfile_".sqlslashes($this->id))."\"";
 } else {
 $sql = "DELETE FROM imgresizecache WHERE filename = \"".sqlslashes($this->file)."\"";
 }
 query($sql);
 }

 
 function setFile($filename) {
 $this->errno = 0;
 if (file_exists($filename)) {
 $this->file = $filename;
 
 } else {
 $this->error("Datei '$filename' existiert nicht. <br>");
 $this->errno = 1;
 }
 }

 function setId($id) {
 $this->errno = 0;
 $sql = "SELECT id FROM contentfiledata WHERE contentfile_id=".sqlf_tl_num($id);
 $rs = query($sql);
 if($rs["arr"][0]["id"]) {
 $this->id = $id;
 $this->idDB = true;
 } else {
 $this->errno = 1;
 $this->error("Datei mit der ID $id existiert nicht.");
 }
 }

 
 function load_file($filename) {
 $this->errno = 0;
 if (file_exists($filename)) {
 $this->file = $filename;
 $this->outfile = "";
 $this->rendered = false;
 $this->imgtype = "";
 $this->getImageType();
 $this->normcachekey = "";
 $this->normalizeImgProps();
 } else {
 $this->error("Datei '$filename' existiert nicht.");
 $this->errno = 1;
 }
 return $this->errno;
 }

 
 function load_dbdata($id) {
 $this->isDB = true;
 $this->errno = 0;
 $this->id = $id;
 $sql = "SELECT binarycontent FROM contentfiledata WHERE contentfile_id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $this->imgData = $rs["arr"][0]["binarycontent"];
 if(strlen($this->imgData)==0) {
 $this->errno = 1;
 $this->error("An error occured while loading image $id from the DB.");
 }
 $this->outfile = "";
 $this->rendered = false;
 $this->imgtype = "";
 $this->getImageType();
 $this->normcachekey = "";
 $this->normalizeImgProps();
 }

 
 function getImageType() {
 global $IM_IDENTIFY_PATH;
 if (!$this->imgtype) {
 if (!$this->force_identify) {
 $sql = "SELECT normprops FROM imgresizecache WHERE filename = \"".sqlslashes($this->file)."\"";
 $rs = query($sql);
 } else {
 $rs = array("num"=>0);
 }
 if ($rs["num"]) {
 $n = unserialize($rs["arr"][0]["normprops"]);
 $this->imgwidth = $n["orig_width"];
 $this->imgheight = $n["orig_height"];
 $this->imgtype = $n["orig_type"];
 $this->imgdpix = $n["orig_dpix"];
 $this->imgdpiy = $n["orig_dpiy"];
 } else {
 $this->errno = 0;
 $f = $this->file;
 if (!$IM_IDENTIFY_PATH) {
 $this->error("No IM_IDENTIFY_PATH set.");
 }

 $identify = node_escapeshellcmd($IM_IDENTIFY_PATH);
 $f = node_escapeshellpath($f);
 if($this->isDB) {
 $tmpfilepath = $this->writeTmpFile();
 $info = `$identify -verbose $tmpfilepath`;
 } else {
 $info = `$identify -verbose $f 2>&1`;
 }
 $info = explode("\n",$info);
 $found = 0;
 $found_geometry = false;
 while (list($key, $val) = each($info)) {
 if (!$found_geometry && eregi("^ *geometry: ([0-9]+)x([0-9]+)",$val, $regs)) {
 $this->imgwidth = (int)$regs[1];
 $this->imgheight = (int)$regs[2];
 $found++;
 $found_geometry = true;
 }
 if (eregi("^ +format: ([a-zA-Z0-9]+)",$val, $regs)) {
 $this->imgtype = $regs[1];
 $found++;
 }
 if (eregi("^ +Resolution: ([0-9]+)x([0-9]+).*",$val, $regs)) {
 $this->imgdpix = (int)$regs[1];
 $this->imgdpiy = (int)$regs[2];
 }
 }
 if ($found < 2) {
 
 
 $this->imgtype = -1;
 $this->imgwidth = -1;
 $this->imgheight = -1;
 }
 }
 }
 return $this->imgtype;
 }

 function writeTmpFile() {
 if($this->isDB) {
 $tmpfilepath = $this->cachedir."/".$this->id."-tmp";
 $fp = @fopen($tmpfilepath, "w");
 if (!$fp) halt(7,"Could not write $tmpfilepath");
 fwrite($fp,$this->imgData);
 fclose($fp);
 return $tmpfilepath;
 }
 }

 function getApplicationType() {
 $this->getImageType();

 switch ($this->imgtype) {
 case "JPEG": $type = "image/jpeg"; break;
 case "PNG": $type = "image/png"; break;
 case "GIF": $type = "image/gif"; break;
 default: $type = "application/octet-stream";
 }

 return $type;
 }

 
 function setProp($property,$value) {
 $this->imgprops[$property] = $value;
 }

 function unsetProp($property) {
 unset($this->imgprops[$property]);
 }

 function getProp($property) {
 return $this->imgprops[$property];
 }

 function getImageProp($property) {
 $this->normalizeImgProps();
 return $this->normprops[$property];
 }

 
 
 
 
 
 
 
 
 
 
 function normalizeImgProps() {
 if ($this->normcachekey != serialize($this->imgprops)) {
 $n = array();
 $p = $this->imgprops;

 $w = $this->setpxsize($p["width"],$this->imgwidth);
 $h = $this->setpxsize($p["height"],$this->imgheight);
 $mw = $this->setpxsize($p["maxwidth"],$this->imgwidth);
 $mh = $this->setpxsize($p["maxheight"],$this->imgheight);

 if (!$w && !$h) {
 if (($mw && !$mh) || ($mw && $mh && ($this->imgwidth/$this->imgheight >= $mw/$mh))) {
 $w = ($mw < $this->imgwidth || $p["force"])?$mw:$this->imgwidth;
 $h = (int) (($w/$this->imgwidth)*$this->imgheight);
 } else if (($mh && !$mw) || ($mw && $mh && ($this->imgwidth/$this->imgheight <= $mw/$mh))) {
 $h = ($mh < $this->imgheight || $p["force"])?$mh:$this->imgheight;
 $w = (int) (($h/$this->imgheight)*$this->imgwidth);
 } else {
 $w = $this->imgwidth;
 $h = $this->imgheight;
 }
 } else if (!$w) {
 $w = (int) (($h/$this->imgheight)*$this->imgwidth);
 if ($mw && $w > $mw) $w = $mw;
 } else if (!$h) {
 $h = (int) (($w/$this->imgwidth)*$this->imgheight);
 if ($mh && $h > $mh) $h = $mh;
 }

 $n["width"] = (int) $w;
 $n["height"] = (int) $h;

 $n["type"] = ($p["type"])?$p["type"]:$this->imgtype;

 $n["orig_width"] = $this->imgwidth;
 $n["orig_height"] = $this->imgheight;
 $n["orig_type"] = $this->imgtype;
 $n["orig_dpix"] = $this->imgdpix;
 $n["orig_dpiy"] = $this->imgdpiy;

 if ($p["antialias"]) $n["antialias"] = true;

 $this->normprops = $n;
 $this->normcachekey = serialize($this->imgprops);
 $this->rendered = false;
 }

 }

 
 function printImage() {
 global $FEATURE;
 $this->renderImg();

 $fs = filesize($this->cachedir."/".$this->outfile);
 if($this->isDB) {
 $sql = "SELECT name FROM contentfile WHERE id=".sqlf_tl_num($this->id);
 $rs = query($sql);
 $fn = $rs["arr"][0]["name"];
 } else {
 $fn = basename($this->file);
 }
 $ft = $this->getApplicationType();
 header("Accept-Range: bytes");
 header("Content-Type: $ft");
 header("Content-Lenght: $fs");
 if ( !$FEATURE["no_filename_dispo"] ) header("Content-Disposition: filename=$fn");
 if (file_exists($this->cachedir."/".$this->outfile.".inwork")) {
 header("Cache-Control: no-cache");
 } else {
 header("Expires: ". gmdate("D, d M Y H:i:s", time() + 5184000) . " GMT");
 header("Cache-Control: max-age=5184000");
 }

 $f = fopen($this->cachedir."/".$this->outfile,"r");
 $c = fread($f, $fs);
 fclose($f);
 echo $c;

 }

 function saveImage($tofile) {
 $this->renderImg();
 copy($this->cachedir."/".$this->outfile,$tofile);
 }

 function getImageTag($addimg='border="0"') {
 $this->renderImg();
 $w = (!empty($this->normprops["maxwidth"]) && $this->normprops["width"] > $this->normprops["maxwidth"] ? $this->normprops["maxwidth"] : $this->normprops["width"]);
 $h= (!empty($this->normprops["maxheight"]) && $this->normprops["height"] > $this->normprops["maxheight"] ? $this->normprops["maxheight"] : $this->normprops["height"]);
 return '<img src="' . $this->getImageSrc() . '" width="' . $w . '" height="' . $h . '" ' . $addimg . '>';
 }

 function getImageSrc() {
 global $STAG, $SID, $STAG_PREFIX;
 $this->renderImg();
 $w = $this->normprops["width"];
 $h = $this->normprops["height"];
 if($this->isDB) {
 return "$STAG_PREFIX?sid=$SID&do=14&image_id=" . $this->id 
 . "&image_height=$h&image_width=$w&outfile=" . $this->outfile;
 } else {
 return "$STAG_PREFIX?sid=$SID&do=14&image_filename=" . $this->file 
 . "&image_height=$h&image_width=$w&outfile=" . $this->outfile;
 }
 }

 function getImageHandle() {
 $this->setProp( "type", "png" );
 $this->renderImg();
 return ImageCreateFromPNG($this->cachedir."/".$this->outfile);
 }


 

 function setpxsize($size,$orig) {
 if ($size) {
 if (is_numeric($size)) $w = $size;
 else if (substr($size,-1) == "%") {
 $s = substr($size,0,-1);
 $w = (int) ($orig * ($s/100));
 } else $w = 0;
 } else $w = 0;
 return $w;
 }

 
 function error($error) {
 if ( !$this->warn_on_error )
 halt(7, "ImgResize Class: $error");
 else
 warning( 7, "ImgResize Class: $error");
 }

 function getCacheKey() {
 $this->normalizeImgProps();
 $n = $this->normprops;
 $this->cachekey = "";
 
 $this->cachekey .= $n["type"].";".$n["width"].";".$n["height"].";";
 if ($n["antialias"]) $this->cachekey .= "antialias;";
 }

 
 
 function setCachedFilename() {
 if($this->isDB) {
 $sql = "SELECT id,cachefile,normprops FROM imgresizecache WHERE filename=\"".sqlf_escaped("dbfile_".sqlslashes($this->id))."\" AND keyprop=\"".sqlslashes($this->cachekey)."\"";
 } else {
 $sql = "SELECT id,cachefile,normprops FROM imgresizecache WHERE filename=\"".sqlslashes($this->file)."\" AND keyprop=\"".sqlslashes($this->cachekey)."\"";
 }
 $rs = query($sql);
 $res = false;
 if ($rs["num"]) {
 $this->outfile = $rs["arr"][0]["cachefile"];
 if (!file_exists($this->cachedir."/".$this->outfile)) {
 $res = false;
 } else {
 
 $outfile_inwork = $this->cachedir."/".$this->outfile.".inwork";
 if (file_exists($outfile_inwork) && (time() - filectime ( $outfile_inwork )) > 3600) {
 
 @unlink($this->cachedir."/".$this->outfile);
 @unlink($outfile_inwork);
 $res = false;
 } else {
 $this->normprops = unserialize($rs["arr"][0]["normprops"]);
 $res = true;
 }
 }
 } else {
 if($this->isDB) {
 $sql = "INSERT INTO imgresizecache (filename,normprops,keyprop) VALUES (\"".sqlf_escaped("dbfile_".sqlslashes($this->id))."\",\"".sqlslashes(serialize($this->normprops))."\",\"".sqlslashes($this->cachekey)."\")";
 } else {
 $sql = "INSERT INTO imgresizecache (filename,normprops,keyprop) VALUES (\"".sqlslashes($this->file)."\",\"".sqlslashes(serialize($this->normprops))."\",\"".sqlslashes($this->cachekey)."\")";
 }
 $rs = query($sql);
 $id = $rs["iid"];
 $this->outfile = $id.".cache";

 
 @unlink($this->cachedir."/".$this->outfile);

 $res = false;
 $sql = "UPDATE imgresizecache SET cachefile = \"".sqlslashes($this->outfile)."\" WHERE id = ".sqlf_tl_num($id);
 query($sql);
 }
 return $res;
 }

 
 function renderImg() {
 global $DEBUG, $NODEPATH, $TPL, $IM_CONVERT_PATH;
 $this->getCacheKey();
 if (!$this->rendered) {
 $ex = $this->setCachedFilename();
 if (!$ex) {
 $outfile = $this->cachedir."/".$this->outfile;
 $outfile_inwork = $outfile.".inwork";

 
 touch($outfile_inwork);

 
 copy("$NODEPATH/modules/system/template/$TPL/images/spinner.gif", $outfile);

 
 if ($this->imgprops["smart"]) {
 $n = $this->normprops;
 $newfactor = $n["width"] / $n["height"];
 $oldfactor = $n["orig_width"] / $n["orig_height"];
 
 if ($oldfactor > $newfactor) {
 $n["shave_width"] = (int) (($n["orig_width"] - (($n["orig_height"]*$n["width"])/$n["height"]))/2);
 $n["shave_height"] = 0;
 
 } elseif ($oldfactor < $newfactor ) {
 $n["shave_height"] = (int) (($n["orig_height"] - (($n["orig_width"]*$n["height"])/$n["width"]))/2);
 $n["shave_width"] = 0;
 }
 $this->normprops = $n;
 }

 if ($this->normprops["shave_width"] || $this->normprops["shave_height"]) {
 $param = "-shave ".$this->normprops["shave_width"]."x".$this->normprops["shave_height"]." ";
 }

 $param .= "-geometry ".$this->normprops["width"]."x".$this->normprops["height"]."!";

 if (!$IM_CONVERT_PATH) {
 $this->error("No IM_CONVERT_PATH set.");
 }
 $convert = node_escapeshellcmd($IM_CONVERT_PATH);
 if ($this->isDB) {
 $tmpfilepath = $this->writeTmpFile();
 $param .= " ".node_escapeshellpath($tmpfilepath)." ".$this->normprops["type"].":".node_escapeshellpath($outfile);
 $r = `$convert $param  2>&1`;
 
 } else {
 $param .= " ".node_escapeshellpath($this->file)." ".$this->normprops["type"].":".node_escapeshellpath($outfile);
 $r = `$convert $param 2>&1`;
 }
 
 unlink($outfile_inwork);
 if ($DEBUG["echo"] && $DEBUG["imgresize"] && $r) echo "convert($convert $param) returned ($r)";
 }
 $this->rendered = true;
 }
 }

}

?>
