<?php

class WSDLFunctionsComponent extends FormComponent
{
 function WSDLFunctionsComponent( $label=NULL, $value="" ) {
 parent::FormComponent( $label);
 $this->d_values["t"] = $value;
 }

 
 function toString()
 {
 return $this->d_values["t"];
 }
 
 function setSoapClient(&$soapclient) {
 $this->d_values["t"] = &$soapclient;
 }

 function &getSoapClient() {
 return $this->d_values["t"];
 }

 function setObject(&$obj) {
 $this->setSoapClient($obj);
 }

 function getSelectedFunction() {
 return $this->d_values['func']; 
 }

 function reset(){
 $this->d_values['func'] = NULL;
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 global $ICO_SOAP;
 $soapclient = &$this->getSoapClient();
 $operations = $soapclient->wsdl->getOperations();
 $html = '<table cellpadding=1 cellspacing=0 border=0><tr><td colspan=2><b>'.i18n('SOAP Functions').'</b></td></tr>';
 if (is_array($operations))
 foreach ($operations as $_func => $_dec) {
 unset($_tmp);
 $call = $form->getJsActionCall( new ValueSetterFormAction( $key, 'func', $_func ) );
 $html .= '<tr>';
 $html .= "<td><a href=\"Javascript:$call\">".img($ICO_SOAP)."</a></td>";
 $html .= "<td><a href=\"Javascript:$call\">$_func</a></td>";
 $html .= '</tr>';
 }
 $html .= '</table>';
 return $this->mergeResult( parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html );
 }
 
}


class WSDLComponent extends CollectionComponent
{
 function WSDLComponent( $label, &$soapclient )
 {
 parent::CollectionComponent();
 $this->d_values["showDetails"] = FALSE;
 $this->setComponent( 'l', new WSDLFunctionsComponent(NULL, $soapclient) );
 $this->setComponent( 'f', new ListComponent() );
 $this->setComponent( 'r', new TextAreaComponent(NULL, false, "", REG_TEXT, true, array(5,15,30), 50) );
 $r = &$this->getComponent('r');
 $r->setHidden(true);
 }

 function setSoapClient(&$soapclient) {
 $this->reset();
 $ret = &$this->getComponent('l');
 $ret->setSoapClient($soapclient);
 }

 function &getSoapClient() {
 $ret = &$this->getComponent('l');
 return $ret->getSoapClient();
 }
 
 function reset() {
 $f = &$this->getComponent('f');
 $f->unsetComponents();
 $l = &$this->getComponent('l');
 $l->reset();
 $r = &$this->getComponent('r');
 $r->setText('');
 $r->setHidden(true);
 }

 function getFunctionParams()
 {
 $params = Array();
 if ($this->componentExists('f') )
 {
 $f = &$this->getComponent('f');
 $list = $f->getComponents();
 foreach ($list as $name) 
 {
 unset($c);
 if ($f->componentExists($name) ) {
 $c = &$f->getComponent($name);
 $params[$name] = $c->getText();
 }
 }
 }
 return $params;
 }

 function setResult($value) {
 $r = &$this->getComponent('r');
 $r->setText($value);
 $r->setHidden(false);
 }

 function getSelectedFunction() 
 {
 $soapclient = &$this->getSoapClient();
 if ( $this->componentExists('l') )
 {
 $list = &$this->getComponent('l');
 if (!$soapclient->getError() && $func_name = $list->getSelectedFunction() ) {
 return $func_name;
 }
 }
 return false;
 }

 function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key )
 {
 $html = "<p>&nbsp;</p><table border=0 width='100%'>\n<tr><td valign=top>";
 $soapclient = &$this->getSoapClient();
 $list = &$this->getComponent('l');
 $func = &$this->getComponent('f'); 
 $colspan = 1;
 if ( !$err = $soapclient->getError() ) 
 { 
 $html .= $this->_getComponentHTMLTable( 'l', $form, $prefix, $doCheck, $checkSeverity, $key );
 if ( $func_name = $list->getSelectedFunction() ) 
 {
 $colspan++;
 $html .= "</td><td valign=top>";
 $operationData = $soapclient->getOperationData($func_name);
 $soap_params = Array();
 if ($func_name != $this->d_values['func_name'] )
 {
 $func->unsetComponents();
 $res = &$this->getComponent('r');
 $res->setHidden(true);
 $params = Array();
 if (is_array($operationData['input']['parts'])) 
 {
 foreach ($operationData['input']['parts'] as $soap_param => $type)
 {
 $func->setComponent( $soap_param, new TextAreaComponent($soap_param, true, "", REG_TEXT, true, array(1,7), 25) );
 $params[] = $soap_param;
 }
 }
 }
 $html .= '<b>function '.$func_name.'</b><br>'; 
 $html .= $this->_getComponentHTMLTable( "f", $form, $prefix, $doCheck, $checkSeverity, $key );
 $this->d_values['func_name'] = $func_name;
 }
 } else {
 $func->unsetComponents();
 $html .= 'Error: '.$err;
 }
 $html .= "</td></tr>";
 $html .= "<tr><td".(($colspan > 1)?" colspan=$colspan":'')."><br>";
 $html .= $this->_getComponentHTMLTable( "r", $form, $prefix, $doCheck, $checkSeverity, $key );
 $html .= "</td></tr>";
 $html .= "</table>";
 return $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $html );
 }
}

?>
