<?php

if ( ! perm_can_view_template($TEMPLATE_ID, $FOLDER_ID)
 || ! perm_can_edit_template($TEMPLATE_ID, $FOLDER_ID)) {
 halt(3, "no perms to view template (props) $TEMPLATE_ID in folder $FOLDER_ID");
}

$IS_EDITING = true;

GUIFactory::setMainGUI("main");

if (!$TEMPLATE_ID) halt(7,"template_fill: no template_id: TEMPLATE_ID($TEMPLATE_ID)");
mysession_var_reg("TEMPLATE_ID");

$templateinfo = get_templateinfo($TEMPLATE_ID);

if ($FEATURE["multichannelling"] && !isEditInheritedVerified($T_TEMPLATE, $TEMPLATE_ID, $NODE_ID)) {
 
 $inherited = false;
 $nodeinfo = get_nodeinfo($NODE_ID);

 
 if ($nodeinfo["master_id"] > 0) {
 
 $inherited = $templateinfo["channel_id"] != $NODE_ID;
 }

 if ($inherited) {
 
 $REDO = 13550;
 $OBJ_TYPE = 10006;
 $OBJ_ID = $TEMPLATE_ID;
 $DO_EDIT = $DO;
 $DO_CANCEL = 13013;
 $OBJ_ID_PARAM = "TEMPLATE_ID";
 return;
 }
}

$main = &GUIFactory::getGUI("main");

$main->setCSSEnabled( FALSE );
$main->includeJS("superedit");
$main->includeJS("jquery-1.6.1.min");
if ($FEATURE["no_pageedit_js"]) {
 $main->setMinimalJSEnabled( TRUE );
}

$editable = lock($TEMPLATE_ID,"template");
$p = perm($USER_ID,$T_FOLDER,$FOLDER_ID,17);
if (!$p) $editable = false;

$tpl = get_template_source($TEMPLATE_ID);
$source = $tpl["source"];

$NODERELATED[$DO][] = $TEMPLATE_PREV;
if ($editable) {
 $NODERELATED[$DO][] = $TEMPLATE_SOURCE_EXT;
 $NODERELATED[$DO][] = $TEMPLATE_SAVE;
 if ($FEATURE["template_release"]) {
 $NODERELATED[$DO][] = $TEMPLATE_RELEASE;
 }
}

if ($FEATURE['javaparser'] && !$FEATURE['disable_javaparser_foredit']) {

 node_class("cntemplateobject");
 $baseObj = new CNTemplateObject($TEMPLATE_ID);
 node_class("codeparser");
 $parser = new CodeParser($baseObj, false, true, $editable ? CN_EM_EDIT : CN_EM_PREVIEW, false);
 $source = $parser->render();

 $INPAGEEDIT_TAGS = $parser->getInlineEditableTags();
} else {
 
 if ($FEATURE["xnl"]) {

 node_class("cntemplateobject");
 $baseObj = new CNTemplateObject($TEMPLATE_ID);
 
 $xnlParser = &ParserFactory::getInstanceOf("xnl");
 $xnlParser->setShowErrors(true);
 $xnlParser->setEvaluate(false);
 $xnlParser->setBaseObject($baseObj);
 $xnlParser->setHandleDependencies(false);
 $xnlParser->clearEventMap();
 }
 objtranslatecache_clear($TEMPLATE_ID,$T_TEMPLATE);

 $tags = obj_translate($TEMPLATE_ID,"template",$TEMPLATE_ID,"template",0,$editable);
 $tmp["id"] = $FOLDER_ID;
 $tmp["type"] = $T_FOLDER;
 $foldertags = obj_translate($tmp,"obj");
 if ($FEATURE['template_objprop']) {
 $tmp["id"] = $TEMPLATE_ID;
 $tmp["type"] = $T_TEMPLATE;
 $templatetags = obj_translate($tmp,"obj",$TEMPLATE_ID,"template");
 }
 
 
 
 if (!$tags) $tags = array();
 if (!$foldertags) $foldertags = array();
 if (!$templatetags) $templatetags = array();
 $tags = $templatetags + $foldertags + $tags;
 


 if ( isSupereditEnabled(T_PAGE, true) )
 $invalid_tags = find_tag_errors( $tags );
 else
 $invalid_tags = array();

 if ( count( $invalid_tags ) )
 {
 $REDO = 10020;
 $o_type = "template";
 $redo = $DO;
 }
 else
 {
 $source = code_translate($source,$tags,"template",$editable,Array(),$T_TEMPLATE,$TEMPLATE_ID);
 
 
 if ($FEATURE["xnl"]) {
 $source = $xnlParser->parse($source);
 }
 
 
 }
}



load_menu(12007, $T_TEMPLATE, $TEMPLATE_ID, i18n('374.edit'));

if ($FEATURE["history"]) {
 $res = query("SELECT name FROM template WHERE id = ".sqlf_tl_num($TEMPLATE_ID));
 if ($res["num"] == 1) {
 $JS .="
top.main.ass.GTXHistory.add({
	id: " . $TEMPLATE_ID . ",
	type: \"template\",
	name: \"" . addslashes( $res["arr"][0]["name"] ) . "\",
	href: \"&do=12006&TEMPLATE_ID=$TEMPLATE_ID&FOLDER_ID=$FOLDER_ID&NODE_ID=$NODE_ID\",
	icon: \"?do=11&module=content&img=lock_template.gif\"
});";
 }
}
?>
