<?php

function endsWith($haystack, $needle)
{
 return $needle === "" || substr($haystack, -strlen($needle)) === $needle;
}






function convertToFilename($filename, $defaultExtension) {
 global $FEATURE;
 global $SANITIZE_CHARACTER;
 $filename = trim($filename);

 $actualExtension = "";
 if (endsWith($filename, $defaultExtension)) {
 $actualExtension = $defaultExtension;
 } else {
 $t_pathinfo = pathinfo($filename);
 if ($t_pathinfo['extension']) {
 $actualExtension = '.' . $t_pathinfo['extension'];
 }
 }
 if ($actualExtension) {
 $filename = substr($filename, 0, - strlen($actualExtension));
 }
 if (!$filename) {
 return $filename;
 }

 $maxFilenameLength = 64;
 
 $allowedCharactersRegex = "/[^\s\w\.\-\(\)\[\]{}\$]/";
 $replacementCharacter = '_';

 if( $FEATURE['filename_forcetolower'] ) {
 $filename = strtolower($filename);
 }

 $sanitizeKeys = array_keys($SANITIZE_CHARACTER);

 
 $filename = str_replace(
 $sanitizeKeys,
 array_values($SANITIZE_CHARACTER),
 $filename
 );

 
 
 
 
 
 if ($FEATURE['UTF8']) {
 $filename = htmlentities($filename, ENT_QUOTES, 'UTF-8');

 
 $filename = preg_replace('/&[a-zA-Z0-9#]*;/i', "_", $filename);

 $filename = html_entity_decode($filename, ENT_COMPAT, 'UTF-8');
 }

 $filename = preg_replace($allowedCharactersRegex, $replacementCharacter, $filename);

 if ($actualExtension) {
 $filename = $filename . $actualExtension;
 }

 
 if (strlen($filename) > $maxFilenameLength) {

 $pathInfo = pathinfo($filename);

 if (isset($pathInfo['extension'])) {
 $extension = $pathInfo['extension'];
 }
 else {
 $extension = "";
 }

 
 
 if (!isset($pathInfo['filename'])){
 $pathInfo['filename'] = substr($pathInfo['basename'], 0, strpos($pathInfo['basename'], '.'));
 }

 $hasExtension = (strlen($extension) > 0 || substr($pathInfo['filename'], -1) == '.');
 $newFileNameLength = $maxFilenameLength - strlen($extension);

 if ($hasExtension) {
 $newFileNameLength--;
 }

 if ($newFileNameLength > 0) {
 $filename = mb_strcut($pathInfo['filename'], 0, $newFileNameLength);

 if ($hasExtension) {
 $filename .= '.' . $extension;
 }
 }

 if (strlen($filename) > $maxFilenameLength) {
 
 $filename = mb_strcut($filename, 0, $maxFilenameLength);
 }
 }

 return $filename;
}
