<?php

function parseCode(&$baseObj, $source, $showErrors, $evaluate, $editMode=CN_EM_PUBLISH, $handleDeps=true) {
 
 global $FEATURE;

 $tagParser = &ParserFactory::getInstanceOf("cntag");
 $tagParser->setShowErrors($showErros);
 $tagParser->setEvaluate($evaluate);
 $tagParser->setBaseObject($baseObj);
 $tagParser->setEditMode( $editMode );
 $xnlParser->setHandleDependencies( $handleDeps );
 $tagParser->clearEventMap();

 if ($FEATURE["xnl"]) {
 $xnlParser = &ParserFactory::getInstanceOf("xnl");
 $xnlParser->setShowErrors($showErrors);
 $xnlParser->setEvaluate($evaluate);
 $xnlParser->setBaseObject($baseObj);
 $xnlParser->clearEventMap();
 }
 $source = $tagParser->parse($source);
 if ($FEATURE["xnl"]) {
 $source = $xnlParser->parse($source);
 }
 
 return $source;
}

function parseTagCode(&$baseObj, $source, $tagName) {

 global $FEATURE;

 $tagParser = &ParserFactory::getInstanceOf("cntag");
 $tagErrorPrefix = $tagParser->getErrorPrefix();
 $tagParser->setErrorPrefix( i18n( "Tag {0}",0, $tagName ) );

 if ($FEATURE["xnl"]) {
 $xnlParser = &ParserFactory::getInstanceOf("xnl");
 $xnlErrorPrefix = $xnlParser->getErrorPrefix();
 $xnlParser->setErrorPrefix( i18n( "Tag {0}",0, $tagName ) );
 $props =& $xnlParser->getObjectParser("prop");
 $props->setObject("this",$baseObj);
 $props->setObject("container",$xnlParser->getBaseObject());
 }
 
 $source = $tagParser->parse($source);
 $tagParser->setErrorPrefix( $tagErrorPrefix );

 if ($FEATURE["xnl"]) {
 $source = $xnlParser->parse($source);
 $xnlParser->setErrorPrefix( $xnlErrorPrefix );
 $props->unsetObject("this");
 $props->unsetObject("container");
 }

 return $source;
}

?>
