<?php

class CNSourceObject extends SearchableObject
{
 var $m_id;
 
 function CNSourceObject( $id )
 {
 $this->m_id = $id;
 $this->setViewLinkParams("do=19102&source_id=" . $this->getId());
 }
 
 function getTType()
 {
 global $T_SOURCE;
 return $T_SOURCE;
 }
 
 function getID()
 {
 return $this->m_id;
 }
 
 function onEventNotify( $TType, $id, $changeType, $linkType, $eventObject, $depth, $simulate ) 
 {
 global $DEBUG;
 if ($DEBUG["echo"]) echo "uah, there are some dependencies for me ($this->m_id) on ($TType -> $id)";
 if ( $eventObject->getProperty( "status" ) == 1 ) 
 {
 $sql = "SELECT value.contenttag_id, value.objtag_id, value.templatetag_id, value.globaltag_id ".
 " FROM value, part ".
 "WHERE value.part_id = part.id AND part.type_id=32 AND value.value_ref=".sqlf_tl_num($this->m_id);
 $rs = query( $sql );
 $r = $rs["arr"][0];

 
 if ( $tid = $r["contenttag_id"] ) {
 triggerEvent( T_CONTENTTAG, $tid, EVENT_UPDATE | EVENT_CN_CONTENT, new EventObject(), $simulate );
 } else if ( $tid = $r["objtag_id"] ) {
 triggerEvent( T_OBJTAG, $tid, EVENT_UPDATE | EVENT_CN_CONTENT, new EventObject(), $simulate );
 } else if ( $tid = $r["templatetag_id"] ) {
 triggerEvent( T_TEMPLATETAG, $tid, EVENT_UPDATE | EVENT_CN_CONTENT, new EventObject(), $simulate );
 }
 }
 }

 function getParentTType() {
 return array(T_SOURCE);
 }

 function _getNodeTable() {
 return "datasource";
 }

 function _getBaseFilter() {
 return "name != ''";
 }

 function getIcon() {
 global $ICO_SOURCE;
 return $ICO_SOURCE;
 }

 function getValueFields() {
 return array("name"=>"text");
 }

 function _checkPermission($parentObjectType, $parentObjectId) {
 global $USER_ID;
 return perm($USER_ID, $parentObjectType, $parentObjectId, 0);
 }

 function _checkSearchTerm($searchTerm) {
 if (! $searchTerm) {
 return true;
 }
 $name = $this->getFieldValue("name");
 if (strpos(strtolower($name), strtolower($searchTerm)) !== FALSE) {
 return true;
 }
 return false;
 }
}

class SourceFactory 
{


 function getTypes()
 {
 global $NODE_DATASOURCE;
 $ret = array();
 foreach ( $NODE_DATASOURCE as $key=>$val )
 {
 node_class( $val["class"] ); 
 eval( "\$typename = ".$val["class"]."::getTypeName();");
 $ret[$key] = $typename;
 }
 return $ret;
 }
 
 function getSourcesList()
 {
 $sql = "SELECT id, name FROM datasource WHERE name != '' ORDER BY name";
 $rs = query( $sql );
 $ret = array();
 foreach ( $rs["arr"] as $row )
 {
 $ret[$row["id"]] = $row["name"];
 }
 return $ret;
 }
 
 function getTypeName( $type )
 {
 global $NODE_DATASOURCE;
 $val = $NODE_DATASOURCE[$type];
 
 node_class( $val["class"] ); 
 eval( "\$typename = ".$val["class"]."::getTypeName();");
 return $typename;
 }
 
 function &getInstanceOf( $type )
 {
 global $NODE_DATASOURCE;
 if ( !isset( $NODE_DATASOURCE[$type] ) )
 halt( 101, "SourceFactory::getInstanceOf: invalid type( $type )" );
 $source = $NODE_DATASOURCE[$type];
 node_class( $source["class"] );
 $class = new $source["class"]();
 return $class;
 }

 function sync( &$source, $id )
 {
 global $T_SOURCE;
 if ( !$id )
 {
 warning( 107, "SourceFactory::sync failed, invalid id ($id)" );
 return;
 }
 node_class( "sqltable" );
 $table = new SqlTable( "datasource" ); 
 $valTable = new SqlTable( "datasource_value" );

 $sourceRows = $table->findBy( "id", $id );
 $sourceRow = $sourceRows[0];
 $event = EVENT_UPDATE;
 
 $values = $source->export();
 if ( is_array( $values ) ) 
 {
 $i=1;
 foreach ( $values as $dsid=>$val )
 {
 $valTable->deleteBy( array( "datasource_id", "dsid", "value" ), array( $id, $dsid, $val["value"] ) ); 
 $row = new SqlTableRow( $valTable );
 $row->setValue( "datasource_id", $id );
 $row->setValue( "dsid", $dsid );
 $row->setValue( "dskey", $val["key"] );
 $row->setValue( "value", $val["value"] );
 $row->setValue( "sorder", $i++ );
 $row->save();
 }
 }
 












 }

 
 function store( &$source, $name=FALSE, $id=FALSE )
 {
 global $T_SOURCE;
 node_class( "sqltable" );
 $table = new SqlTable( "datasource" ); 
 $valTable = new SqlTable( "datasource_value" );
 if ( $id )
 {
 $sourceRows = $table->findBy( "id", $id );
 $sourceRow = $sourceRows[0];
 $valTable->deleteBy( "datasource_id", $id );
 $event = EVENT_UPDATE;
 logcmd( W_EDIT, $T_SOURCE, $id );
 }
 else
 {
 $sourceRow = new SqlTableRow( $table );
 $event = EVENT_CREATE;
 logcmd( W_CREATE, $T_SOURCE, $id );
 }
 
 $params = &$source->getParams();
 if ( is_object($params) )
 $params->store();
 if ( $name )
 $sourceRow->setValue( "name", $name );
 $sourceRow->setValue( "source_type", $source->getType() );
 if ( is_object($params) )
 $sourceRow->setValue( "param_id", $params->getID() );
 else 
 $sourceRow->setValue( "param_id", -1 );
 $sourceRow->save();
 $id = $sourceRow->getValue( "id" );
 
 $values = $source->exportValues();
 if ( is_array( $values ) ) 
 {
 $logcmd_info = "Change DS - New Values: ";
 $i=1;
 foreach ( $values as $dsid=>$val )
 {
 $row = new SqlTableRow( $valTable );
 $row->setValue( "datasource_id", $id );
 $row->setValue( "dsid", $dsid );
 $row->setValue( "dskey", $val["key"] );
 $row->setValue( "value", $val["value"] );
 $row->setValue( "sorder", $i++ );
 $row->save();
 $logcmd_info = $logcmd_info . ", " . $val["key"] . "=" . $val["value"];
 }
 global $W_EDIT, $T_SOURCE;
 logcmd( $W_EDIT, $T_SOURCE, $id, $dsid, $logcmd_info );
 }
 
 removeEventDependencies( $T_SOURCE, $id, 2, LINKT_SOURCE );
 triggerEvent( $T_SOURCE, $id, $event, new EventObject() );
 $deps = $source->getEventDependencies();
 if ( is_array( $deps ) )
 {
 foreach ( $deps as $dependency )
 {
 addEventDependency( $dependency["TType"], $dependency["id"], $dependency["eventTypes"],
 $T_SOURCE, $id, LINKT_SOURCE );
 }
 }
 return $id; 
 }

 


 function loadValues( &$dsvalueTable, $id ) {
 $rsv = $dsvalueTable->findBy( "datasource_id", $id, "=", "sorder" );
 $param = array();
 foreach ( $rsv as $value )
 {
 $id = $value->getValue("dsid");
 if ( $id === NULL ) {
 
 $id = $value->getValue("value");
 }
 $param[$id]["key"] = $value->getValue("dskey");
 $param[$id]["value"] = $value->getValue("value");
 } 
 return $param;
 }
 
 function &load( $id )
 {
 node_class( "sqltable" );
 $table = new SqlTable( "datasource" ); 
 $valtable = new SqlTable( "datasource_value" );
 $rs = $table->findBy( "id", $id );
 if ( count($rs) < 1 )
 return FALSE;
 $source = SourceFactory::getInstanceOf( $rs[0]->getValue( "source_type" ) );

 $param = SourceFactory::loadValues( $valtable, $id );
 
 $paramid = $rs[0]->getValue("param_id");
 $source->load( $param, new ParamHelper( $paramid ) );
 
 return array( $rs[0]->getValue("name") => &$source );
 }
 
 function &loadSingle( $id )
 {
 static $cache;
 if (isset($cache[$id])) return $cache[$id];
 
 $sources = &SourceFactory::load( $id );
 if ( !$sources ) return FALSE;
 $source = &$sources[key($sources)];
 $cache[$id] =& $source;
 return $source;
 }
 
 function loadSourceList( $id )
 {
 static $cache = array();
 if ( !isset($cache[$id]) )
 { 
 $source = SourceFactory::loadSingle( $id );
 if ( !$source ) return array();
 if ( $source->needsSync() ) SourceFactory::sync( $source, $id );
 $cache[$id] = $source->export();
 }
 return $cache[$id]; 
 }
}

class DatasourceBuilder extends WizardBuilder
{
 var $m_type = -1;
 var $m_id = -1;
 var $m_doCreate = TRUE;
 var $m_source = FALSE;
 var $m_name = "";
 var $m_action = "";
 var $m_param = "";

 function DatasourceBuilder( $source_id, $type, $action, $param )
 {
 $this->m_action = $action;
 $this->m_param = $param;
 $this->m_type = $type;
 if ( $source_id )
 {
 $source =& SourceFactory::load( $source_id );
 if ( $source ) { 
 $this->m_source = &$source[key($source)];
 $this->m_name = key($source);
 $this->m_type = $this->m_source->getType();
 $this->m_id = $source_id;
 $this->m_source->setFirstStep( 1 );
 $this->m_doCreate = FALSE;
 }
 else
 $this->m_doCreate = TRUE;
 }
 else
 {
 $this->m_doCreate = TRUE;
 }
 }
 
 function getSerializeKey()
 {
 $rs = array();
 $rs["parent"] = parent::getSerializeKey();
 $rs["type"] = $this->m_type;
 $rs["id"] = $this->m_id;
 $rs["docreate"] = $this->m_doCreate;
 $rs["source"] = node_serialize( $this->m_source );
 $rs["name"] = $this->m_name;
 $rs["action"] = $this->m_action;
 $rs["param"] = $this->m_param;
 return $rs;
 }
 
 function initFromSerializeKey( $rs )
 {
 parent::initFromSerializeKey( $rs["parent"] );
 $this->m_type = $rs["type"];
 $this->m_id = $rs["id"];
 $this->m_doCreate = $rs["docreate"];
 $this->m_source = node_unserialize( $rs["source"] );
 $this->m_name = $rs["name"];
 $this->m_action = $rs["action"];
 $this->m_param = $rs["param"];
 }
 
 function updateStep( &$wizard, $stepNr, &$form )
 {
 $this->m_source->updateStep( $wizard, $stepNr, $form );
 }
 
 function createStep( &$wizard, $stepNr, &$form ) 
 {
 if ( $this->m_doCreate )
 {
 $source =& SourceFactory::getInstanceOf( $this->m_type );
 $source->setFirstStep( 1 );
 $this->m_source = &$source;
 }
 $this->m_source->createStep( $wizard, $stepNr, $form );
 }
 
 function done( &$wizard )
 {
 $this->m_source->done( $wizard );
 
 if ( !$this->m_doCreate )
 {
 $id = $this->m_id;
 }
 else
 $id = FALSE;
 $id = SourceFactory::store( $this->m_source, "", $id );
 
 $func = $this->m_action;
 $func( $id, $this->m_param );
 }
 
 function cancel( &$wizard )
 {
 $func = $this->m_action;
 $func( $id, $this->m_param );
 $this->m_source->cancel( $wizard );
 }
}
$NODE_CLASS["datasourcebuilder"] = FALSE;

function &genDatasourceWizard( $source_id, $source_type, $parentForm, $action, $param )
{
 global $ICO_SOURCE;
 node_class( "htmlformwizard" );
 $form = new HtmlFormWizard( "dswizard" );
 if ( $form->isNew() )
 {
 $form->setBuilder( new DatasourceBuilder( $source_id, $source_type, $action, $param ) );
 $form->setNestedForm( $parentForm );
 $form->setHeader( i18n( "Edit Datasource" ), $ICO_SOURCE );
 }
 return $form;
}

?>
