<?php

if ($FEATURE["2dotool_integration"]) {
 node_include('todotool');
}
node_class("codeparser");


function group_exists($name, $mother) {

 global $GROUP_EXISTS;

 if (!$mother) halt(7,"group.cmd.php: group_exists: No mother ($mother)");

 
 if (!is_array($GROUP_EXISTS[$mother])) {
 $a_name = sqlslashes($name);
 $sql = "SELECT id, name FROM usergroup WHERE mother = ".sqlf_tl_num($mother)." AND name = '$a_name'";
 $rs = query($sql);
 if ($rs["num"] > 0)
 $GROUP_EXISTS[$mother] = reduce_array($rs["arr"],"id","name");
 else
 $GROUP_EXISTS[$mother] = Array();
 }

 
 $ret = in_array($name, $GROUP_EXISTS[$mother]);
 
 return $ret;
}


function cmd_group_create($name, $description, $mother) {
 global $TIME, $ERROR, $USER_ID, $T_GROUP, $W_CREATE, $DIC;

 if (!perm_usergroup($USER_ID,$mother,8)) {
 $ERROR = i18n('824.no_permission_to_create_a');
 return false;
 }

 if (!$name) halt(7, "cmd_group_create: No name ($name)");
 if (!isset($mother) || $mother == "") halt(7, "cmd_group_create: No mother isset or empty. mother($mother)");

 if (group_exists($name, $mother)) {
 $ERROR = i18n('a_group_with_this_name');
 return false;
 }

 
 $name = sqlslashes($name);
 $description = sqlslashes($description);
 
 $sql = "INSERT INTO usergroup (name,description,mother,edate,cdate,editor,creator) 
          VALUES ('$name','$description',".sqlf_tl_num($mother).",".sqlf_tl_num($TIME).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($USER_ID).")";
 $rs = query($sql);

 
 
 
 duplicate_group_perm($mother, $rs["iid"]);

 
 logcmd($W_CREATE, $T_GROUP, $mother , 0, "cmd_group_create");
 triggerEvent( T_GROUP, $rs["iid"], EVENT_CREATE, new EventObject() );
 triggerEvent( T_GROUP, $mother, EVENT_UPDATE, new EventObject(null, array("children")));
 
 return $rs["iid"];

}


function cmd_delete_group_rec($group_id) {
 
 $sql = "SELECT id FROM usergroup WHERE mother = ".sqlf_tl_num($group_id);
 $rs = query($sql,1);

 $allowsub = true;

 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 
 $allowsub = cmd_delete_group_rec($val["id"]) && $allowsub;
 }
 }

 
 if (!$allowsub) return false;

 
 $sql = "SELECT user_id FROM user_group WHERE usergroup_id = ".sqlf_tl_num($group_id);
 $rs = query($sql,1);

 $allowuser = true;

 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 
 $perm = user_removecheck($val["user_id"],$group_id,1);
 if ($perm) {
 $sql = "DELETE FROM user_group WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND user_id = ".sqlf_tl_num($val["user_id"]);
 query($sql);
 } else $allowuser = false;
 }
 }

 
 if ($allowuser) {
 $sql = "DELETE FROM usergroup WHERE id = ".sqlf_tl_num($group_id);
 query($sql);
 $sql = "DELETE FROM perm WHERE usergroup_id = ".sqlf_tl_num($group_id);
 query($sql);
 return true;
 } else {
 return false;
 }
}

function cmd_group_del($id = 0) {
 global $W_DEL, $T_GROUP, $USER_ID, $DIC, $ERROR; 
 
 if (!$id) halt(0,"no group.id to delete");

 $error = false;
 
 if (is_array($id)) {
 while (list($key,$val) = each($id)) { 
 $perm = perm_usergroup($USER_ID,$key,10);
 if ($perm) {
 $rs = cmd_delete_group_rec($key);
 if (!$rs) {
 if (!$ERROR) $ERROR = i18n('a_group_could_not_be');
 $error++;
 }
 
 logcmd($W_DEL, $T_GROUP, $key , 0, "cmd_group_del");
 triggerEvent(T_GROUP, $key, EVENT_DELETE, new EventObject());
 } else {
 $ERROR = i18n('1124.you_are_not_allowed_to');
 $error++;
 }
 }
 } else {
 $perm = perm_usergroup($USER_ID,$key,10);
 if ($perm) {
 if (!cmd_delete_group_rec($key)) {
 if (!$ERROR) $ERROR = i18n('a_group_could_not_be');
 $error++;
 }
 
 logcmd($W_DEL, $T_GROUP, $key , 0, "cmd_group_del");
 triggerEvent( T_GROUP, $id, EVENT_DELETE, new EventObject() );
 } else {
 $ERROR = i18n('1124.you_are_not_allowed_to');
 $error++;
 }
 }

 
 return $error;
}




function cmd_group_move($source, $target) {

 global $ERROR,$USER_ID,$TIME,$DIC,$W_MOVE,$T_GROUP, $T_GROUPADMIN;

 if (!$source) halt(0,"cmd_group_move: No source to move");
 if (!$target) halt(0,"cmd_group_move: No target to move");

 
 if (!perm($USER_ID,$T_GROUPADMIN,"",8)) {
 $error = true;
 $ERROR = i18n('858.you_have_no_permission_to');
 return $error;
 }

 
 $error = false;

 $moved_ids = array();
 $old_mothers = array();

 
 if (is_array($source)) {
 while (list($key,$val) = each($source)) {
 $moved_ids[] = $key;
 $info = get_usergroupinfo($key);
 $old_mothers[] = $info["mother"];
 
 
 
 
 $groups = array();
 $groups = user_findgroups($USER_ID,$key);
 if (in_array($target,$groups)) {
 $ERROR = i18n('destination_group_and');
 return true;
 }
 if (!perm($USER_ID,$T_GROUPADMIN,"",10)) {
 $ERROR = i18n('one_or_more_groups_could');
 return true;
 }
 $tmp .= " id = ".sqlf_tl_num($key)." OR";
 $log[] = $key;
 }
 
 $sql = "SELECT name FROM usergroup WHERE $tmp 1=2";
 $rs = query($sql);
 
 while (list($k,$v) = each($rs["arr"])) {
 if (group_exists($v["name"], $target)) {
 $ERROR = i18n('the_name_of_a_group');
 return true;
 }
 }


 } else {
 $moved_ids[] = $source;
 $info = get_usergroupinfo($source);
 $old_mothers[] = $info["mother"];
 
 
 
 
 $groups = array();
 $groups = user_findgroups($USER_ID,$source);
 if (in_array($target,$groups)) {
 $ERROR = i18n('destination_group_and');
 return true;
 }
 if (!perm($USER_ID,$T_GROUPADMIN,"",10)) {
 $ERROR = i18n('one_or_more_groups_could');
 return true;
 }

 $tmp = "id = ".sqlf_tl_num($source)." OR";
 
 $sql = "SELECT name FROM usergroup WHERE $tmp 1=2";
 $rs = query($sql);
 if (group_exists($rs["arr"][0]["name"], $target)){
 $ERROR = i18n('the_name_of_a_group');
 return true;
 }
 $log[] = $source;
 }

 
 if (!$error) {
 
 $sql = "SELECT perm FROM perm WHERE usergroup_id = ".sqlf_tl_num($target)." AND o_type = ".sqlf_tl_num($T_GROUPADMIN);
 $rs = query($sql,1);
 $t_perm = $rs["arr"][0]["perm"];
 $t_len = strlen($t_perm);
 
 
 reset($log);
 while (list($k, $v) = each ($log)) {
 logcmd($W_MOVE, $T_GROUP, $v , $target, "cmd_group_move");

 
 $sql = "SELECT perm FROM perm WHERE usergroup_id = ".sqlf_tl_num($v)." AND o_type = ".sqlf_tl_num($T_GROUPADMIN);
 $rs = query($sql,1);
 $s_perm = $rs["arr"][0]["perm"];

 
 for ($i = 0; $i < strlen($s_perm); $i++) {
 if ($i < $t_len) $tbit = $t_perm[$i]; else $tbit = "0";
 if ($t_perm[$i] == "0" && $s_perm[$i] == "1") {
 perm_set_groupbit($v,$i,0);
 }
 }
 }

 $sql = "UPDATE usergroup SET mother = ".sqlf_tl_num($target).", edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($USER_ID)." WHERE $tmp 1=2";
 if (!$error) {
 
 query($sql);
 }
 }
 
 $old_mothers = array_unique($old_mothers);
 while (list($key, $val) = each($old_mothers)) {
 triggerEvent( T_GROUP, $val, EVENT_UPDATE, new EventObject(null, array("children")) );
 }

 
 triggerEvent( T_GROUP, $target, EVENT_UPDATE, new EventObject(null, array("children")) );

 
 while (list($key, $val) = each($moved_ids)) {
 triggerEvent( T_GROUP, $val, EVENT_UPDATE, new EventObject(null, array("mother")) );
 } 
 
 return $error;
}


function cmd_group_update($id,$name,$description) {

 if (!$id) halt(0,"no group.id to update");

 global $TIME, $USER_ID, $W_EDIT, $T_GROUP, $DIC;

 
 $sql = "SELECT name, mother FROM usergroup WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $same_name = $rs["arr"][0]["name"] == $name;
 $mother = $rs["arr"][0]["mother"];
 if (!$same_name) {
 if (group_exists($name, $mother)) {
 global $ERROR;
 $ERROR = i18n('a_group_with_this_name');
 return false;
 }
 }

 
 $name = sqlslashes($name);
 $description = sqlslashes($description);
 
 $sql = "UPDATE usergroup SET name='$name', description='$description', 
          edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($USER_ID)." WHERE id = ".sqlf_tl_num($id);
 query($sql);

 
 logcmd($W_EDIT, $T_GROUP, $id , 0, "cmd_group_update");
 triggerEvent( T_GROUP, $id, EVENT_UPDATE, new EventObject() );
 
 return $id;
}



function cmd_group_user_add($group_id, $user_id) {

 global $TIME, $USER_ID, $W_EDIT, $T_GROUPADMIN, $ERROR, $DIC;

 if (!$group_id) halt(0,"no group.id to add users");

 if (!perm_usergroup($USER_ID,$group_id,11) || $group_id == 1 || $group_id == 2) {
 $ERROR = i18n('you_dont_have_the');
 return false;
 }

 

 if ($user_id) {
 
 if (is_array($user_id)) {
 while (list($key,$val) = each($user_id)) {
 $sql = "INSERT INTO user_group (usergroup_id, user_id, cdate, creator) VALUES (".sqlf_tl_num($group_id).", ".sqlf_tl_num($key).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($USER_ID).")";
 $rs = query($sql);
 
 logcmd($W_EDIT, $T_GROUPADMIN, $group_id , $key, "cmd_group_user_add");
 }
 } else {
 $sql = "INSERT INTO user_group (usergroup_id, user_id, cdate, creator) VALUES (".sqlf_tl_num($group_id).", ".sqlf_tl_num($user_id).", ".sqlf_tl_num($TIME).", ".sqlf_tl_num($USER_ID).")";
 $rs = query($sql);
 
 logcmd($W_EDIT, $T_GROUPADMIN, $group_id , $user_id, "cmd_group_user_add");
 }
 } else {
 $ERROR = i18n('to_add_a_user_select_one');
 return false;
 }
 if (is_array($user_id)) {
 reset($user_id);
 while (list($key, $val) = each($user_id)) {
 triggerEvent( T_USER, $key, EVENT_UPDATE, new EventObject(null, array("groups")) );
 }
 } else {
 triggerEvent( T_USER, $user_id, EVENT_UPDATE, new EventObject(null, array("groups")) );
 }
 triggerEvent( T_GROUP, $group_id, EVENT_UPDATE, new EventObject(null, array("users")) );

 return $group_id;
}



function cmd_group_user_remove($group_id, $user_id) {
 global $W_EDIT, $T_GROUPADMIN, $USER_ID, $DIC, $ERROR;

 if (!$group_id) halt(0,"no group.id to delete");

 $error = 0;

 
 if (is_array($user_id)) {
 
 $userlist = user_getuser_list($USER_ID);

 while (list($key,$val) = each($user_id)) {
 if (in_array($key,$userlist)) {
 if (user_removecheck($key, $group_id)) {
 
 $sql = "SELECT count(*) AS c FROM user_group WHERE user_id = ".sqlf_tl_num($key);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 1) {
 $tmp .= " user_id = ".sqlf_tl_num($key)." OR";
 
 logcmd($W_EDIT, $T_GROUPADMIN, $group_id , "-".$key, "cmd_group_user_remove");
 triggerEvent( T_GROUP, $group_id, EVENT_UPDATE, new EventObject(null, array("users")) );
 triggerEvent( T_USER, $key, EVENT_UPDATE, new EventObject(null, array("groups")) );
 } else {
 $ERROR = i18n('user_belongs_only_to_the');
 $error++;
 }
 }
 } else {
 $ERROR = i18n('a_user_could_not_be');
 $error++;
 }
 }
 } else if ($user_id) {
 if (user_check($USER_ID,$user_id)) {
 $sql = "SELECT count(*) AS c FROM user_group WHERE user_id = ".sqlf_tl_num($user_id);
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 1) {
 $tmp = "user_id = ".sqlf_tl_num($id)." OR";
 
 logcmd($W_EDIT, $T_GROUPADMIN, $group_id , "-".$user_id, "cmd_group_user_remove");
 triggerEvent( T_GROUP, $group_id, EVENT_UPDATE, new EventObject(null, array("users")) );
 triggerEvent( T_USER, $user_id, EVENT_UPDATE, new EventObject(null, array("groups")) );
 } else {
 $ERROR = i18n('user_belongs_only_to_the');
 $error++;
 }
 } else {
 $ERROR = i18n('a_user_could_not_be');
 $error++;
 }
 }

 $sql = "DELETE FROM user_group WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND ($tmp 1=2)";
 query($sql);

 if ($error == 0) {
 $error = false;
 }
 return $error;
}

function cmd_perm_update($group_id, $o_type, $o_id, $perm,$rec=0) {
 global $PERM, $W_PERM, $USER_ID, $T_GROUPADMIN, $GROUP_PERM, $USER_PERM, $USERGROUP_PERM, $T_TYPE, $T_FOLDER, $T_NODE;

 if (!$group_id) halt(0,"no group.id to set permissions on");
 if (!$o_type) halt(0,"no object type to set permissions on");
 if (!$o_id) halt(0,"no object id to set permissions on");

 if (!is_array($o_id)) $o_id = array($o_id);
 
 
 node_include("PERM");
 if (!perm_usergroup($USER_ID,$group_id,13)) return false;
 if (isset($PERM[$o_type][1])) {
 foreach ($o_id as $key=>$id) {
 
 if (!perm($USER_ID,$o_type,$id,1)) unset($o_id[$key]);
 }
 if (count($o_id) == 0) return false;
 }

 $sqlid = (count($o_id)==1)?"o_id = \"".sqlslashes($o_id[0])."\"":"o_id IN (".implode(",",sqlf_tl_num_array($o_id)).")";
 
 $sql = "SELECT o_id FROM perm WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND o_type = ".sqlf_tl_num($o_type)." AND $sqlid";
 $rs = query($sql);

 if ($rs["num"] > 0) {
 
 if ($perm === "00000000000000000000000000000000") {
 $sql = "DELETE FROM perm WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND o_type = ".sqlf_tl_num($o_type)." AND $sqlid";
 query($sql);
 } else {
 $sql = "UPDATE perm SET perm='".sqlf_escaped($perm)."' WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND o_type = ".sqlf_tl_num($o_type)." AND $sqlid";
 query($sql);
 }
 }
 
 $updarr = array();
 foreach ($rs["arr"] as $val) 
 $updarr[$val["o_id"]] = true;

 
 if ($perm !== "00000000000000000000000000000000") {
 foreach ($o_id as $id) {
 if ($updarr[$id]) continue;
 $sql = "INSERT INTO perm (usergroup_id,o_type,o_id,perm) VALUES (".sqlf_tl_num($group_id).",".sqlf_tl_num($o_type).",\"".sqlslashes($id)."\",'".sqlf_escaped($perm)."')";
 query($sql);
 }
 }

 $GROUP_PERM = Array();
 $USER_PERM = Array();
 $USERGROUP_PERM = Array();

 if ($rec) {
 if ($o_type == $T_GROUPADMIN) {
 $permdef = $PERM[$T_GROUPADMIN];
 reset($permdef);
 while (list($bit,$val) = each($permdef)) {
 perm_set_groupbit($group_id,$bit,$perm[$bit]);
 }
 } else {
 foreach ($o_id as $id) {
 perm_set_recursiveperms($group_id,$o_type,$id);
 }
 }
 }

 
 $t_type = $T_TYPE[$o_type]["use_perm"];
 $t_sql = $T_TYPE[$o_type]["use_perm_sql"];
 if ($t_type && $t_sql) {
 foreach ($o_id as $id) {
 $rs = query($t_sql.sqlf_value($id));
 $t_id = $rs["arr"][0]["id"];
 perm_set_perms($group_id, $t_type, $t_id, perm2string(convert_perm($group_id,$o_type,$id,$t_type,$t_id)));
 }
 }

 
 $javaParser = & CodeParser :: getJavaParser();
 $javaParser->refreshGroupPerms($group_id);

 
 foreach ($o_id as $id) {
 logcmd($W_PERM, $o_type, $id , $group_id, "cmd_perm_update");
 if ($o_type == $T_FOLDER || $o_type == $T_NODE) {
 triggerEvent( $T_FOLDER, $id, EVENT_UPDATE, new EventObject(null, array("permissions")) );
 }
 }

 
 return false;
}

function cmd_perm_set_typeperm($group_id, $o_type, $o_id, $type, $perm, $rowval = "") {

 global $T_TYPE, $PERM_ROWVAL;

 if ($o_type == $type) {
 $error = cmd_perm_update($group_id,$o_type,$o_id,$perm);
 }

 
 if (!is_array($rowval)) $rowval = $PERM_ROWVAL;

 



 foreach ($o_id as $id) {
 $rs = tree_get_subfolders($o_type,$id,$T_TYPE, $rowval);

 
 if (is_array($rs) && count($rs) > 0) {
 while (list($key,$val) = each($rs)) {
 $error = cmd_perm_set_typeperm($group_id, $val["type"],array($val["id"]), $type, $perm, $val["val"]) || $error;
 }
 }
 }

 return $error;
}

?>
