<?php

class ObjectPropertyObject extends SearchableObject {

 var $id = 0;

 function ObjectPropertyObject($id=0) {
 parent::SearchableObject($id);
 $this->setID($id);
 $this->setViewLinkParams("do=453&id=" . $this->getId());
 }

 function _initObject() {
 $parentInit = parent::_initObject();
 if (! $parentInit) {
 $this->_setError(new NodeException("initObject in parent returned false"));
 return false;
 }
 if (!$this->getID()) {
 $this->_setError(new NodeException("initObject: empty id"));
 return false;
 }
 $sql = "SELECT category_id, name_id FROM objprop WHERE objtag_id = ".sqlf_tl_num($this->getID());
 $rs = query($sql);
 if ($rs["num"] == 0) {
 $this->_setError(new NodeException("initObject: could not find object for id (".$this->getID().") in objprop."));
 return false;
 } else {
 return $this->initFromResultSet($rs["arr"][0], "", true);
 }
 }

 function _setID($id) {
 $this->id = $id;
 }

 function getID() {
 return $this->id;
 }

 function getTType() {
 return T_OBJPROPELEMENT;
 }

 function getParentTType() {
 return array(T_OBJPROP);
 }

 function _getNodeTable() {
 return "objtag";
 }

 function getValueFields() {
 return array( 'name' => 'text', 'category_id' => 'int', 'name_id' => 'int' );
 }

 function _getBaseFilter() {
 return "obj_id = 0";
 }

 function _getObjectTypeColumn() {
 return "obj_type";
 }

 function getIcon() {
 global $ICO_OBJPROP;
 return $ICO_OBJPROP;
 }

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 if (! in_array($objecttype, $this->getParentTType())) {
 return null;
 }
 $sql = "SELECT " . sqlf_table($this->_getNodeTable()) . ".* FROM " . sqlf_table($this->_getNodeTable()) .
 " WHERE " . sqlf_field($this->_getObjectTypeColumn()) . " = " . sqlf_value($objectid);
 if ($this->_getBaseFilter()) {
 $sql .= " AND " . $this->_getBaseFilter();
 }
 $rs = query($sql);
 return $this->_processResultSet($rs, $searchterm);
 }

 function getDisplayName() {
 $prettyNameId = $this->getFieldValue("name_id");
 if ($prettyNameId) {
 $prettyName = $this->_idToDicUser( $prettyNameId );
 if ($prettyName) {
 return $prettyName;
 }
 }
 return $this->getFieldValue("name");
 }

 function getCategoryName() {
 $category_id = $this->getFieldValue("category_id");
 if ($category_id > 0) {
 $category = NodeFactory::getStaticInstanceOf(T_OBJPROP_CATEGORY, $category_id);
 return $category->getName();
 }
 return null;
 } 

 function _checkPermission($parentObjectType, $parentObjectId) {
 global $USER_ID;
 return perm($USER_ID, $this->getTType(), $this->getID(), 0);
 }

 function _checkSearchTerm($searchTerm) {
 if (! $searchTerm) {
 return true;
 }
 $name = $this->getFieldValue("name");
 $prettyName = $this->getDisplayName();
 if (strpos(strtolower($name), strtolower($searchTerm)) !== FALSE) {
 return true;
 }
 if (strpos(strtolower($prettyName), strtolower($searchTerm)) !== FALSE) {
 return true;
 }
 return false;
 }

 function delete() {
 return cmd_objprop_del(array($this->getID() => true));
 }
}

class ObjectPropertyCategory extends NodeObject {
 var $id;

 function ObjectPropertyCategory($id) {
 parent::NodeObject($id);
 }

 function _getNodeTable() {
 return "objprop_category";
 }

 function getIcon() {
 global $ICO_OBJPROPADMIN;
 return $ICO_OBJPROPADMIN;
 }

 function getTType() {
 return T_OBJPROP_CATEGORY;
 }

 function getValueFields() {
 return array("name_id"=>"int", "id"=>"int");
 }

 function getName() {
 return $this->_idToDicUser( $this->getFieldValue("name_id") );
 }

 function _setID($id) {
 $this->id = $id;
 }

 function getID() {
 return $this->id;
 }
}

?>
